structure BinaryTree_TacticStyle_Code = 
struct

datatype inta = Pls | Min | Bit0 of inta | Bit1 of inta | Number_of_int of inta;

datatype nat = Zero_nat | Suc of nat;

fun pred (Bit1 k) = Bit0 k
  | pred (Bit0 k) = Bit1 (pred k)
  | pred Min = Bit0 Min
  | pred Pls = Min;

fun uminus_int (Number_of_int w) = Number_of_int (uminus_int w)
  | uminus_int (Bit1 k) = Bit1 (pred (uminus_int k))
  | uminus_int (Bit0 k) = Bit0 (uminus_int k)
  | uminus_int Min = Bit1 Pls
  | uminus_int Pls = Pls;

fun succ (Bit1 k) = Bit0 (succ k)
  | succ (Bit0 k) = Bit1 k
  | succ Min = Pls
  | succ Pls = Bit1 Pls;

fun plus_int (Number_of_int v) (Number_of_int w) = Number_of_int (plus_int v w)
  | plus_int (Bit1 k) (Bit1 l) = Bit0 (plus_int k (succ l))
  | plus_int (Bit1 k) (Bit0 l) = Bit1 (plus_int k l)
  | plus_int (Bit0 k) (Bit1 l) = Bit1 (plus_int k l)
  | plus_int (Bit0 k) (Bit0 l) = Bit0 (plus_int k l)
  | plus_int k Min = pred k
  | plus_int k Pls = k
  | plus_int Min k = pred k
  | plus_int Pls k = k;

fun minus_int (Number_of_int v) (Number_of_int w) =
  Number_of_int (plus_int v (uminus_int w));

fun less_eq_int (Bit1 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_eq_int (Bit1 k1) (Bit0 k2) = less_int k1 k2
  | less_eq_int (Bit0 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_eq_int (Bit0 k1) (Bit0 k2) = less_eq_int k1 k2
  | less_eq_int (Bit1 k) Min = less_eq_int k Min
  | less_eq_int (Bit0 k) Min = less_eq_int k Min
  | less_eq_int (Bit1 k) Pls = less_int k Pls
  | less_eq_int (Bit0 k) Pls = less_eq_int k Pls
  | less_eq_int Min (Bit1 k) = less_eq_int Min k
  | less_eq_int Min (Bit0 k) = less_int Min k
  | less_eq_int Min Min = true
  | less_eq_int Min Pls = true
  | less_eq_int Pls (Bit1 k) = less_eq_int Pls k
  | less_eq_int Pls (Bit0 k) = less_eq_int Pls k
  | less_eq_int Pls Min = false
  | less_eq_int Pls Pls = true
  | less_eq_int (Number_of_int k) (Number_of_int l) = less_eq_int k l
and less_int (Bit1 k1) (Bit1 k2) = less_int k1 k2
  | less_int (Bit1 k1) (Bit0 k2) = less_int k1 k2
  | less_int (Bit0 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_int (Bit0 k1) (Bit0 k2) = less_int k1 k2
  | less_int (Bit1 k) Min = less_int k Min
  | less_int (Bit0 k) Min = less_eq_int k Min
  | less_int (Bit1 k) Pls = less_int k Pls
  | less_int (Bit0 k) Pls = less_int k Pls
  | less_int Min (Bit1 k) = less_int Min k
  | less_int Min (Bit0 k) = less_int Min k
  | less_int Min Min = false
  | less_int Min Pls = true
  | less_int Pls (Bit1 k) = less_eq_int Pls k
  | less_int Pls (Bit0 k) = less_int Pls k
  | less_int Pls Min = false
  | less_int Pls Pls = false
  | less_int (Number_of_int k) (Number_of_int l) = less_int k l;

fun nat_aux i n =
  (if less_eq_int i (Number_of_int Pls) then n
    else nat_aux (minus_int i (Number_of_int (Bit1 Pls))) (Suc n));

fun nat i = nat_aux i Zero_nat;

fun eq_nat Zero_nat Zero_nat = true
  | eq_nat (Suc nat) (Suc nat') = eq_nat nat nat'
  | eq_nat Zero_nat (Suc nat') = false
  | eq_nat (Suc nat') Zero_nat = false;

fun less_nat m (Suc n) = less_eq_nat m n
  | less_nat n Zero_nat = false
and less_eq_nat (Suc m) n = less_nat m n
  | less_eq_nat Zero_nat n = true;

datatype tree = Tip | Nd of tree * nat * tree;

fun eq_tree Tip Tip = true
  | eq_tree (Nd (tree1, nat, tree2)) (Nd (tree1', nat', tree2')) =
    eq_tree tree1 tree1' andalso (eq_nat nat nat' andalso eq_tree tree2 tree2')
  | eq_tree Tip (Nd (tree1', nat', tree2')) = false
  | eq_tree (Nd (tree1', nat', tree2')) Tip = false;

fun rm (Nd (l, x, r)) = (if eq_tree r Tip then x else rm r);

fun rem (Nd (l, x, r)) = (if eq_tree r Tip then l else Nd (l, x, rem r));

fun memb e Tip = false
  | memb e (Nd (t1, x, t2)) =
    (if less_nat e x then memb e t1
      else (if less_nat x e then memb e t2 else true));

fun binsert x Tip = Nd (Tip, x, Tip)
  | binsert x (Nd (t1, y, t2)) =
    (if less_nat x y then Nd (binsert x t1, y, t2)
      else (if less_nat y x then Nd (t1, y, binsert x t2) else Nd (t1, y, t2)));

fun remove x Tip = Tip
  | remove x (Nd (l, y, r)) =
    (if less_nat x y then Nd (remove x l, y, r)
      else (if less_nat y x then Nd (l, y, remove x r)
             else (if eq_tree l Tip then r else Nd (rem l, rm l, r))));

val test : bool =
  memb (nat (Number_of_int (Bit0 (Bit0 (Bit1 Pls)))))
    (remove (nat (Number_of_int (Bit1 (Bit1 Pls))))
      (binsert (nat (Number_of_int (Bit0 (Bit0 (Bit1 Pls)))))
        (binsert (nat (Number_of_int (Bit1 (Bit1 Pls)))) Tip)));

end; (*struct BinaryTree_TacticStyle_Code*)
